Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tools.ant.types
Class DataType

    java.lang.Object
      |
      +--org.apache.tools.ant.types.DataType

Direct Known Subclasses:
  FileSet, Mapper, Path, PatternSet

public abstract class DataType
extends java.lang.Object

Base class for those classes that can appear inside the build file as stand alone data types.

This class handles the common description attribute and provides a default implementation for reference handling and checking for circular references that is appropriate for types that can not be nested inside elements of the same type (i.e. <patternset> but not <path>).

Author:
  Stefan Bodewig

Field Summary
`protected boolean` | `checked` Are we sure we don't hold circular references?
`protected java.lang.String` | `description` The descriptin the user has set.
`protected Reference` | `ref` Value to the refid attribute.

Constructor Summary
`DataType()`

Method Summary
`protected BuildException` | `circularReference()` Creates an exception that indicates the user has generated a loop of data types referencing each other.
`protected void` | `dieOnCircularReference(java.util.Stack stk, Project p)` Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
`java.lang.String` | `getDescription()` Return the description for the current data type.
`boolean` | `isReference()` Has the refid attribute of this element been set?
`protected BuildException` | `noChildrenAllowed()` Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
`void` | `setDescription(java.lang.String desc)` Sets a description of the current data type.
`void` | `setRefid(Reference ref)` Set the value of the refid attribute.
`protected BuildException` | `tooManyAttributes()` Creates an exception that indicates that refid has to be the only attribute if it is set.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### description

    protected java.lang.String description

  The descriptin the user has set.

### ref

    protected Reference ref

  Value to the refid attribute.

### checked

    protected boolean checked

  Are we sure we don't hold circular references?

  Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

Constructor Detail

### DataType

    public DataType()

Method Detail

### setDescription

    public void setDescription(java.lang.String desc)

  Sets a description of the current data type. It will be useful in commenting what we are doing.

### getDescription

    public java.lang.String getDescription()

  Return the description for the current data type.

### isReference

    public boolean isReference()

  Has the refid attribute of this element been set?

### setRefid

    public void setRefid(Reference ref)

  Set the value of the refid attribute.

  Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do the must call `super.setRefid`.

### dieOnCircularReference

    protected void dieOnCircularReference(java.util.Stack stk,
                                          Project p)
                                   throws BuildException

  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

  If one is included, throw a BuildException created by `circularReference`.

  This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

  The general contract of this method is that it shouldn't do anything if ``checked`` is true and set it to true on exit.

### tooManyAttributes

    protected BuildException tooManyAttributes()

  Creates an exception that indicates that refid has to be the only attribute if it is set.

### noChildrenAllowed

    protected BuildException noChildrenAllowed()

  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

### circularReference

    protected BuildException circularReference()

  Creates an exception that indicates the user has generated a loop of data types referencing each other.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000 Apache Software Foundation. All Rights Reserved.